% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}
\usepackage{../../../../grammar}
\usepackage{graphicx}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Four.III\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}


\begin{questions}
\question
Decide if the string~$\sigma$ matches the regular expression~$R$.
\begin{parts}
\part $\sigma=\str{0010}$, $R=\re{0*10}$
\begin{solution}
Yes.
    One match is 
    $\underbracket{\str{00}}_{\re{0*}}\underbracket{\str{1}}_{\re{1}}\underbracket{\str{0}}_{\re{0}}$.
\end{solution}

\part $\sigma=\str{101}$, $R=\re{1*01}$
\begin{solution}
Yes
    This works: 
    $\underbracket{\str{1}}_{\re{1*}}\underbracket{\str{0}}_{\re{0}}\underbracket{\str{1}}_{\re{1}}$.
\end{solution}

\part $\sigma=\str{101}$, $R=\re{1*(0|1)}$
\begin{solution}
No.
    To match, the~\str{0} must be a final character.
\end{solution}

\part $\sigma=\str{101}$, $R=\re{1*(0|1)*}$
\begin{solution}
Yes.
    A match is 
    $\underbracket{\str{1}}_{\re{1*}}\underbracket{\str{01}}_{\re{(0|1)*}}$.
\end{solution}

\part $\sigma=\str{01}$, $R=\re{1*01*}$
\begin{solution}
Yes.
    Here is a match: 
    $\underbracket{\emptystring}_{\re{1*}}\underbracket{\str{0}}_{\re{0}}\underbracket{\str{1}}_{\re{1*}}$.
\end{solution}
\end{parts}


\question
Give a regular expression for each language.
Use $\Sigma=\kleenestar{\set{\str{a},\str{b}}}$.
\begin{parts}
\part The set of strings starting with \str{b}. 
\begin{solution}
\re{b(a|b)*}
\end{solution}

\part The set of strings whose second-to-last character is \str{a}.
\begin{solution}
\re{(a|b)*a(a|b)}
\end{solution}

\part The set of strings containing at least one of each character.
\begin{solution}
The two characters could come in the order 
$\ldots{}\str{a}\ldots{}\str{b}\ldots{}$ or the order
$\ldots{}\str{a}\ldots{}\str{b}\ldots{}$.
So this works:
\re{(a|b)*((a(a|b)*b)|(b(a|b)*a))(a|b)*}.
\end{solution}

\part The strings where the number of \str{a}'s is divisible by three.
\begin{solution}
The \str{a}'s must come in triplets: \re{(b*ab*ab*ab*)*b*}.
\end{solution}
% \item The strings with at most one set of consecutive \str{a}'s.
\end{parts}

\question
  Give a regular expression for each language of bitstrings.
  \begin{parts}
  \part The number of \str{0}'s is even.
  \begin{solution}
  Here the \str{0}'s come in pairs:~\re{(1*01*01*)*1*}.
  \end{solution}

  \part There are more than two \str{1}'s.
  \begin{solution}
  Here two of the \str{1}'s have no 
    Kleene star's: \re{0*10*10*1*(0|1)*}.
  \end{solution}

  \part The number of \str{0}'s is even and 
   there are more than two \str{1}'s.
   \begin{solution}
   One that will do is to start with the expression from the prior item
  and replace all the \str{0}'s with the expression from the first item.
  \begin{center}
    \re{((1*01*01*)*1*)*1((1*01*01*)*1*)*1((1*01*01*)*1*)*1*(((1*01*01*)*1*)|1)*}
  %     (1*01*01*)*(1|010)1*(1*01*01*)*(1|010)1*(1*01*01*)*(1|010)1*((1*01*01*)*(1|010)1*)*
  \end{center}
   \end{solution}
  \end{parts}

\question
Give a Finite State machine that accepts the language described by the
regular expression.
\begin{parts}
\part \re{a*ba}
\begin{solution}
Here is a nondeterministic machine.
\begin{center}
  \includegraphics{asy/automata006.pdf}
\end{center}
If you prefer a deterministic machine then this will do.
\begin{center}
  \includegraphics{asy/automata007.pdf}
\end{center}
\end{solution}

\part \re{ab*(a|b)*a}
\begin{solution}
Here is a nondeterministic machine.
Note that \re{b*(a|b)*} is equivalent to \re{(a|b)*}.
\begin{center}
  \includegraphics{asy/automata008.pdf}
\end{center}
Of course, we have a way to convert nondeterministic machines into 
deterministic ones, so if you prefer 
a deterministic one then you can consider this an 
abbreviation. 
\end{solution}
\end{parts}



\end{questions}
\end{document}
